export interface IECONode {
    data: any;
    linkColor?: string;
    background?: string;
    color?: string;
    width?: number;
    height?: number;
    children?: IECONode[];
    selected?: boolean;
}
export declare enum Orientation {
    RO_TOP = 0,
    RO_BOTTOM = 1,
    RO_RIGHT = 2,
    RO_LEFT = 3
}
export declare enum Aligment {
    NJ_TOP = 0,
    NJ_CENTER = 1,
    NJ_BOTTOM = 2
}
export declare enum Fill {
    NF_GRADIENT = 0,
    NF_FLAT = 1
}
export declare enum Colorize {
    CS_NODE = 0,
    CS_LEVEL = 1
}
export declare enum Search {
    SM_DSC = 0,
    SM_META = 1,
    SM_BOTH = 2
}
export declare enum Select {
    SL_MULTIPLE = 0,
    SL_SINGLE = 1,
    SL_NONE = 2
}
export declare class ECONode {
    id: any;
    pid: any;
    dsc: any;
    w: any;
    h: any;
    c: any;
    bc: any;
    linkColor: any;
    data: any;
    siblingIndex: number;
    dbIndex: number;
    XPosition: number;
    YPosition: number;
    prelim: number;
    modifier: number;
    leftNeighbor: any;
    rightNeighbor: any;
    nodeParent: ECONode;
    nodeChildren: ECONode[];
    isCollapsed: boolean;
    canCollapse: boolean;
    isSelected: boolean;
    constructor(id: any, pid: any, dsc: any, w: any, h: any, c: any, bc: any, lc: any, meta: any);
    _getLevel(): any;
    _isAncestorCollapsed(): any;
    _setAncestorsExpanded(): any;
    _getChildrenCount(): number;
    _getLeftSibling(): any;
    _getRightSibling(): any;
    _getChildAt(i: any): ECONode;
    _getChildrenCenter(tree: any): number;
    _getFirstChild(): ECONode;
    _getLastChild(): ECONode;
    _drawChildrenLinks(tree: any): any[];
}
export declare class ECOTree {
    config: any;
    version: string;
    canvasoffsetTop: number;
    canvasoffsetLeft: number;
    maxLevelHeight: any[];
    maxLevelWidth: any[];
    previousLevelNode: any[];
    rootYOffset: number;
    rootXOffset: number;
    nDatabaseNodes: any[];
    mapIDs: {};
    root: any;
    iSelectedNode: number;
    iLastSearch: number;
    width: number;
    height: number;
    constructor();
    _firstWalk(tree: any, node: any, level: any): void;
    _apportion(tree: any, node: any, level: any): void;
    _secondWalk(tree: any, node: any, level: any, X: any, Y: any): void;
    _positionTree(): void;
    _setLevelHeight(node: any, level: any): void;
    _setLevelWidth(node: any, level: any): void;
    _setNeighbors(node: any, level: any): void;
    _getNodeSize(node: any): any;
    _getLeftmost(node: any, level: any, maxlevel: any): any;
    _selectNodeInt(dbindex: any, flagToggle: any): void;
    _collapseAllInt(flag: any): void;
    _selectAllInt(flag: any): void;
    UpdateTree(): void;
    add(id: any, pid: any, dsc: any, w: any, h: any, c: any, bc: any, lc: any, meta: any, selected?: boolean): void;
    searchNodes(str: any): void;
    selectAll(): void;
    unselectAll(): void;
    collapseAll(): void;
    expandAll(): void;
    collapseNode(nodeid: any, upd: any): void;
    selectNode(nodeid: any, upd: any): void;
    setNodeTitle(nodeid: any, title: any, upd: any): void;
    setNodeMetadata(nodeid: any, meta: any, upd: any): void;
    setNodeColors(nodeid: any, color: any, border: any, upd: any): void;
    getSelectedNodes(): any[];
}
